<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="90px">
      <el-form-item label="房间名称：" prop="name">
        <el-input
          v-model.trim="queryParams.name"
          placeholder="请输入房间名称"
          clearable
          size="small"
          style="width: 140px"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="楼层名称：" prop="floorName">
        <el-input
          v-model.trim="queryParams.floorName"
          placeholder="请输入楼层名称"
          clearable
          size="small"
          style="width: 140px"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="建筑名称：" prop="buildName">
        <el-input
          v-model.trim="queryParams.buildName"
          placeholder="请输入建筑名称"
          clearable
          size="small"
          style="width: 140px"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:admin:add']"
        >新增</el-button>
      </el-form-item>
    </el-form>

    <el-table v-loading="loading" :data="adminList" height="calc(100vh - 28vh)">
      <el-table-column label="房间名称" align="center" prop="roomName"  show-overflow-tooltip />
      <el-table-column label="楼层名称" align="center" prop="floorName"  show-overflow-tooltip />
      <el-table-column label="建筑名称" align="center" prop="buildName"  show-overflow-tooltip />
      <el-table-column label="备注" align="center" prop="remark"  show-overflow-tooltip />
      <el-table-column label="创建人" align="center" prop="creatMan"  show-overflow-tooltip />
      <el-table-column label="创建时间" align="center" prop="addTime"  show-overflow-tooltip />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:admin:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:admin:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 修改、新增对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body :before-close="cancel" :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="auto" >
        <el-row :gutter="20">
          <el-col :span="12" >
            <el-form-item label="房间名称" prop="roomName">
              <el-input v-model.trim="form.roomName" placeholder="请填写房间" @input="onInput()" maxlength="15" show-word-limit/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="建筑名称" prop="buildId">
              <el-select  @change="getBuildId($event)"
                v-model="form.buildId"
                placeholder="请选择建筑名称"
                clearable
                size="small"
              >
                <el-option
                  v-for="(dict,index) in buildListData"
                  :key="index"
                  :label="dict.name"
                  :value="dict.id"
                />
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12" >
            <el-form-item label="楼层名称" prop="floorId">
              <el-select
                v-model="form.floorId"
                placeholder="请选择楼层名称"
                clearable
                size="small"
              >
                <el-option
                  v-for="(dict,index) in floorListData"
                  :key="index"
                  :label="dict.name"
                  :value="dict.id"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="备注" prop="remark">
              <el-input type="textarea" v-model.trim="form.remark" placeholder="请填写备注" @input="onInput()" rows="4" maxlength="25" show-word-limit/>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.current"
      :limit.sync="queryParams.size"
      @pagination="getList"
    />
  </div>
</template>
<script>
import {  getBuilding, getFloor, addRoom, delRoom, updateRoom, getRoom } from "@/api/business/buildMange";
export default {
  name: "Floor",
  data() {
    return {
      exportLoading:false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 参数表格数据
      adminList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        current: 1,
        size: 20,
        name: undefined,
        floorName:undefined,
        buildName:undefined
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        roomName: [
          { required: true, message: "房间名称不能为空",  trigger: "blur"  }
        ],
        floorName: [
          { required: true, message: "地理坐标不能为空", trigger: ["blur",'change'] }
        ],
        buildId: [
          { required: true, message: "建筑名称不能为空", trigger: ["blur",'change'] }
        ],
        floorId: [
          { required: true, message: "楼层名称不能为空", trigger: ["blur",'change'] }
        ],
      },
      //建筑下拉
      buildListData:[],
      //建筑下拉
      floorListData:[],
    };
  },
  created() {
    this.getList();//初始化table
    this.buildList()//初始化建筑下拉
  },
  methods: {
    //强制el-input刷新
    onInput(){
        this.$forceUpdate();
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
      this.floorListData = []
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.queryParams = {
        name:undefined,
        current:1,
        size:20
      }
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 表单重置
    reset() {
      this.form = {};
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.current = 1;
      this.getList();
    },
    /** 查询参数列表 */
    getList() {
      this.loading = true;
      getRoom(this.queryParams).then(response => {
        this.adminList = response.data.records;
        this.total = response.data.total;
        this.loading = false;
      });
    },

    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.title = "修改";
      this.form = row
      this.form.buildId = Number(this.form.buildId)
      this.form.floorId = Number(this.form.floorId)
      this.open = true;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "新增";
    },
    /** 提交按钮 */
    submitForm(row) {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.loading = true

          if (this.form.id != undefined) {
            updateRoom(this.form).then(response => {
              this.loading = false,
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
              setTimeout(() =>{
                this.floorListData = []
              },1000)
            }).catch(()=>{
              this.loading = false
            })
          } else {
            addRoom(this.form).then(response => {
              this.loading = false,
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
              setTimeout(() =>{
                this.floorListData = []
              },1000)
            }).catch(()=>{
              this.loading = false
            })
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delRoom(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },

    /* 建筑列表 */
    buildList(){
      getBuilding(this.queryParams).then(response => {
        this.buildListData = (response.data).records.map(val =>{
          return {
            id:val.id,
            name:val.buildName
          }
        })
        console.log(this.buildListData)
      });
    },
    /* 楼层列表 */
    floorList(id){
      getFloor({buildId:id,current:1,size:100}).then(response => {
        this.floorListData = (response.data).records.map(val =>{
          return {
            id:val.id,
            name:val.floorName
          }
        })

        console.log(this.floorListData)

      });
    },
    getBuildId(id){
      this.floorList(id)//初始化楼层下拉
    }


  }
};
</script>
